#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/interrupt.h>
#include <linux/device.h>
#include <linux/proc_fs.h>
#include <linux/irq.h>
#include <linux/timer.h>
#include <linux/delay.h>

#include <asm/uaccess.h>
#include <asm/irq.h>

#define I8042_POLL_PERIOD       HZ/20

//static irq_desc_t *my_irq_desc = (irq_desc_t *)0x023a6000;
static struct timer_list *my_i8042_timer = (struct timer_list *)MY_TIMER_ADDR;

static irqreturn_t (*org_handler)(int, void *, struct pt_regs *);
static irqreturn_t my_handler(int x, void *y, struct pt_regs *z)
{
	//printk("<0>CANPOSKB my_handler\n");
	return 1;
}

static ssize_t canposkb_write(struct file *filp, const char __user *buf, size_t count, loff_t *ppos)
{
	char c;

	copy_from_user(&c, buf, 1);

	//printk("<0>CANPOSKB hack %c\n", c);

	if ( c == '0' )
	{
//		org_handler = my_irq_desc[1].action->handler;
//		my_irq_desc[1].action->handler = my_handler;
		disable_irq(1);
		mod_timer(my_i8042_timer, jiffies + 100*HZ);
	}
	else if ( c == '1' )
	{
//		my_irq_desc[1].action->handler = org_handler;
		enable_irq(1);
		mod_timer(my_i8042_timer, jiffies + I8042_POLL_PERIOD);
	}

	return 1;
}

const static struct file_operations canposkb_f = {
	.write = canposkb_write
};

static int __init canposkb_init(void)
{
	struct proc_dir_entry *entry;

	//printk("<0>CANPOSKB init\n");
	entry = create_proc_entry("canposkb", 0777, NULL);
	entry->proc_fops = &canposkb_f;
	return 0;
}

static void __exit canposkb_exit(void)
{
	//printk("<0>CANPOSKB exit\n");
	remove_proc_entry("canposkb", NULL);
}

module_init(canposkb_init);
module_exit(canposkb_exit);

MODULE_LICENSE("GPL");
